# General defines
%define shortnname r2d2bot
%define daemonname r2d2bot
%define username artoo-detoo
%define groupname artoo-detoo


Name:           r2d2bot
Version:        1.01
Release:        1%{?dist}
Summary:        R2D2Bot - Telegram Bot for system notifications
License:        GPLv3
Group:          Applications/Internet
URL:            https://www.serzik.com
Source:         https://dist.suffit.org/perl/%{name}-%{version}.tar.gz
BuildArch:      noarch

# Build
BuildRequires:  perl
BuildRequires:  perl(ExtUtils::MakeMaker)

# Pragmas
BuildRequires:  perl(base)
BuildRequires:  perl(constant)
BuildRequires:  perl(feature)
BuildRequires:  perl(vars)

# Runtime
BuildRequires:  perl(CTK) >= 2.03
BuildRequires:  perl(Encode::Locale)
BuildRequires:  perl(Mojolicious)
BuildRequires:  perl(Text::ParseWords)

# General
Requires:       perl(:MODULE_COMPAT_%(eval "$(perl -V:version)"; echo $version))
Requires:       openssl
Requires:       gnupg2
Requires:       perl(CTK) >= 2.03
Requires:       perl(Encode::Locale)
Requires:       perl(Mojolicious)
Requires:       perl(Text::ParseWords)


%{?perl_default_filter}


%description
Telegram Bot for system notifications


%prep
%setup -q -n %{name}-%{version}


%build
%{__perl} Makefile.PL INSTALLDIRS=vendor
%{__make} %{?_smp_mflags}


%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}
%{__make} install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -exec rm -f {} ';'
find %{buildroot} -type f -name perllocal.pod -exec rm -f {} ';'
%{_fixperms} %{buildroot}/*

# Filesystem.
mkdir -p %{buildroot}%{_sharedstatedir}/%{shortnname}
mkdir -p %{buildroot}%{_rundir}/%{shortnname}


# Install systemd unit files.
mkdir -p %{buildroot}%{_unitdir}
%{__install} -pDm644 src/%{daemonname}.service %{buildroot}%{_unitdir}/%{daemonname}.service
%{__install} -pDm644 src/%{daemonname}.default %{buildroot}%{_sysconfdir}/sysconfig/%{daemonname}


%check
%{__make} test


%pre
getent group %{groupname} &> /dev/null || groupadd -r %{groupname} &> /dev/null
getent passwd %{username} &> /dev/null || useradd -r -g %{groupname} -s /sbin/nologin %{username} &> /dev/null


%post
%systemd_post %{daemonname}.service


%preun
%systemd_preun %{daemonname}.service


%postun
%systemd_postun_with_restart %{daemonname}.service


%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}


%files
%defattr(-,root,root,-)
%doc Changes README
%license LICENSE
%config(noreplace) %{_sysconfdir}/%{shortnname}
%{perl_vendorlib}/*
%{_bindir}/*
%{_mandir}/man1/*.1*
%{_mandir}/man3/*.3*
%{_datadir}/%{shortnname}/*
%{_unitdir}/%{daemonname}.service
%config(noreplace) %{_sysconfdir}/sysconfig/%{daemonname}
%dir %attr(0755, %{username}, %{groupname}) %{_sharedstatedir}/%{shortnname}


%changelog
* Mon Nov 06 2023 Serz Minus <abalama@cpan.org> - 1.01-1
- Added image (sendPhoto) handler to agent
- Added video (sendVideo) handler to agent
- Added audio (sendAudio) handler to agent
- Added document (sendDocument) handler to agent

* Mon Nov 15 2021 Serz Minus <abalama@cpan.org> - 1.00-1
- Initial release
